//Code original par Neamar. Rutilisation libre.
//neamar@neamar.fr
//Date : 2008

//Ligne de commande pour compiler :
//(aprs s'tre plac dans le bon dossier, cf. http://neamar.fr/Res/Compiler_AS3/)
//
//bash mxmlc Sources/SkyFire/SkyFire.as -default-size 640 480 -compiler.strict

//Life begins when you can spend your spare time programming instead of watching television.

package
{

	import flash.display.Stage;//...
	import flash.display.StageDisplayState;//Pour le plein cran
	import flash.display.StageScaleMode;//Pour le plein cran
	import flash.display.Sprite;//La classe de base, fort utile !
	import flash.events.Event;//Les venements "de bases", classe dont drive MouseEvent
	import flash.events.MouseEvent;//Interaction utilisateur//souris
	import flash.geom.Rectangle;//Un rectangle : x,y, width, height
	import flash.geom.Point;//Un point tout ce qu'il y a de plus normal : dfini par (x,y).
	import flash.text.TextField;//Champ de texte. Classe assez vaste, utilise uniquement pour l'affichage de texte ici. Peut tre du texte au format HTML.

	import flash.filters.BitmapFilter;//Classe globale pour les filtres
	import flash.filters.GlowFilter;//Filtre d'irridescence (clairage, le plus utilis)
	import flash.filters.BlurFilter//Flouter
	import flash.filters.BevelFilter;//Effet de biseau, appliqu sur le "Plus de jeux".
	import flash.filters.DisplacementMapFilter;
	import flash.filters.DisplacementMapFilterMode;

	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.BitmapDataChannel;
	import flash.display.GradientType;
	import flash.display.SpreadMethod;
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.geom.ColorTransform;

	import flash.geom.Matrix;

	import Particules.*;


	[SWF(width = "640", height = "480", frameRate = 25)];//Quelques paramtres pour la compilation. Ils sont cependant redfinis dans la ligne de commande, mais laisss ici pour des raisons sentimentales (sic)

	public class SkyFire extends Sprite
	{
		private static const MaxDistance:int=8;
		public static const Size:Point=new Point(800,600)

		public var d_Fond:BitmapData=new BitmapData(Size.x,Size.y,false,0x000000);
		public var Fond:Bitmap;
		public var Operateur:Artificier;

		public var Items:Array=new Array();

		private var k:int=0;

		function SkyFire():void
		{
			include "../Trace.as";
 			Fond=new Bitmap(d_Fond);

 			addChild(Fond);

 			function toggleFullScreen(e:MouseEvent):void
			{
				stage.displayState = StageDisplayState.FULL_SCREEN;
				stage.scaleMode= StageScaleMode.SHOW_ALL;
			}

			stage.addEventListener(MouseEvent.CLICK,toggleFullScreen);
			Operateur = new Artificier();
			addEventListener(Event.ENTER_FRAME,Move);


			function Move(e:Event):void
			{

				d_Fond.lock();//Economiser les ressources

				//Flouter les anciens venements
				//function applyFilter(sourceBitmapData:BitmapData, sourceRect:Rectangle, destPoint:Point, filter:BitmapFilter):void
				d_Fond.applyFilter(d_Fond,new Rectangle(0,0,Size.x,Size.y),new Point(0,0),new BlurFilter(8,8));

				for each(var Item:* in Operateur.Feux)
				{
					var Position1:Point=Item.Pos;
					if(Position1.y<=Size.y)
					{
						Item.Iterate();


						var Position2:Point=Item.Pos;

						var Distance:Number=Point.distance(Position1,Position2);
						var Intermediaire:Point=Position2.clone();
						var NbIterations:int=0;
						if(Distance!=0)
							NbIterations=Math.ceil(Distance/MaxDistance);

						for(var i:int=0;i<=NbIterations;i++)
						{
							//function draw(source:IBitmapDrawable, matrix:Matrix = null, colorTransform:ColorTransform = null, blendMode:String = null, clipRect:Rectangle = null, smoothing:Boolean = false):void

							if(NbIterations!=0)
								Intermediaire=Point.interpolate(Position2,Position1,i/NbIterations);

							d_Fond.draw(Item,new Matrix(1,0,0,1,Intermediaire.x,Intermediaire.y),Item.transform.colorTransform);
						}
					}
				}

				d_Fond.unlock();

			}
		}
	}
}
